# Generated by go2rpm 1.11.1
%bcond_without check

# https://github.com/strukturag/nextcloud-spreed-signaling
%global goipath         github.com/strukturag/nextcloud-spreed-signaling
Version:                1.2.4

%gometa -L -f

%global common_description %{expand:
Standalone signaling server for Nextcloud Talk.}

%global golicenses      LICENSE
%global godocs          docs CHANGELOG.md README.md docker/README.md

Name:           nextcloud-spreed-signaling
Release:        %autorelease
Summary:        Standalone signaling server for Nextcloud Talk

License:        AGPL-3.0-only
URL:            %{gourl}
Source0:        %{gosource}
Source1:        signaling.service
Source2:        signaling-proxy.service
Source3:        signaling.sysusers

Patch0:         nextcloud-spreed-signaling-fix_makefile.patch

BuildRequires:  /usr/bin/easyjson
BuildRequires:  /usr/bin/protoc-gen-go
BuildRequires:  /usr/bin/protoc-gen-go-grpc
BuildRequires:  make
BuildRequires:  protobuf-compiler
BuildRequires:  systemd-rpm-macros
%{?sysusers_requires_compat}

%description %{common_description}

%package proxy
Summary: A proxy server for signaling

BuildRequires: systemd-rpm-macros

%description proxy
A proxy server for signaling.

%gopkg

%prep
%goprep -A
%autopatch -p1

%generate_buildrequires
%go_generate_buildrequires

%build
ln -s %{_builddir} /builddir/build/src
export GOPATH="/builddir/build/:${GOPATH:+${GOPATH}:}/usr/share/gocode"
export GO111MODULE=off
cd /builddir/build/src/%{name}-%{version}
make common
%gobuild -o %{gobuilddir}/bin/signaling %{goipath}/server
%gobuild -o %{gobuilddir}/bin/proxy %{goipath}/proxy

# this one is only for the testing phase
%gobuild -o %{gobuilddir}/bin/client %{goipath}/client

%install
install -m 0755 -vd %{buildroot}%{_bindir}
install -m 0755 -vd %{buildroot}%{_sysconfdir}/signaling
install -m 0755 -vp %{gobuilddir}/bin/signaling %{buildroot}%{_bindir}/
install -m 0755 -vp %{gobuilddir}/bin/proxy %{buildroot}%{_bindir}/
install -m 0644 -vp server.conf.in %{buildroot}%{_sysconfdir}/signaling/server.conf
install -m 0644 -vp proxy.conf.in %{buildroot}%{_sysconfdir}/signaling/proxy.conf
install -m 0755 -vd %{buildroot}%{_unitdir}
install -m 0644 -vp %{SOURCE1} %{buildroot}%{_unitdir}/
install -m 0644 -vp %{SOURCE2} %{buildroot}%{_unitdir}/
install -p -D -m 0644 %{SOURCE3} %{buildroot}%{_sysusersdir}/%{name}.conf

%if %{with check}
%check
%gocheck
%endif

%pre
%sysusers_create_compat %{SOURCE3}

%post
%systemd_post signaling.service

%post proxy
%systemd_post signaling-proxy.service

%preun
%systemd_preun signaling.service

%preun proxy
%systemd_preun signaling-proxy.service

%postun
%systemd_postun_with_restart signaling.service

%postun proxy
%systemd_postun_with_restart signaling-proxy.service

%files
%license LICENSE
%doc docs CHANGELOG.md README.md
%attr(0755,root,root) %dir %{_sysconfdir}/signaling
%config(noreplace) %{_sysconfdir}/signaling/server.conf
%{_bindir}/signaling
%ghost %{_bindir}/client
%{_unitdir}/signaling.service
%{_sysusersdir}/%{name}.conf

%files proxy
%license LICENSE
%doc docs CHANGELOG.md README.md
%attr(0755,root,root) %dir %{_sysconfdir}/signaling
%config(noreplace) %{_sysconfdir}/signaling/proxy.conf
%{_bindir}/proxy
%{_unitdir}/signaling-proxy.service

%changelog
%autochangelog
